<%@ Control debug="true" %>

<%@ Import namespace="system.drawing" %>
<%@ import namespace="projectpal.bo" %>

<script runat="server">


private Sub Page_Load(Sender As Object, E As EventArgs)

	SetupFormData()
		
end sub


sub SetupFormData ()
	
	dim myProject as new projectpal.bo.boProject
	dim projectData as new projectpal.bo.structProject

	projectData = myProject.Detail(session("projectID"))
		
	'setup screen for PM edit mode
	if session("ISPM") = 1 then
		'setup status field (if PM show combo with edit functionality
		ddlStatus.visible = true
		txtStatus.visible = false

		ddlStatus.datasource = myProject.GetStatusCodes(0)
		ddlStatus.DataTextField="name"
		ddlStatus.DataValueField="statuscodeid"
		ddlStatus.SelectedIndex = projectData.status
		ddlStatus.DataBind()		

		ddlStatus.backcolor = color.Linen
		ddlStatus.font.bold=true

		'setup enddate field
		txtEndDate.backcolor = color.Linen
		txtEndDate.font.bold=true
		txtEndDate.readonly=true
		btnEndDate.visible=true

		'setup Description field
		txtDescription.readonly=false
		txtDescription.backcolor = color.linen
		txtDescription.font.bold = true

		'Setup Save Changes button
		btnSaveData.visible="true"

		'setup STage grid Edit
		dgStage.Columns(6).visible="true"

	else
		ddlStatus.visible = false
		txtStatus.visible = true
	end if

	
	txtProjectName.text = projectData.name
	txtStartDate.text = ctype(projectData.startdate, string)
	txtEndDate.text = ctype(projectData.enddate, string)
	txtDescription.text = projectData.description

	BindGrid()


end Sub

sub bindGrid()

	dim myStage as new projectpal.bo.boStage
	dgStage.datasource=myStage.GetStagesByProject(session("projectID"))
	dgStage.databind()

end sub

Sub btnCalEndDate_Click(sender As Object, e As ImageClickEventArgs) 

	calEndDate.SelectedDate = ctype(txtEndDate.text, datetime)
	calEndDate.visible = not calEndDate.visible

End Sub


Sub calEndDate_Changed (sender as Object, e As EventArgs)

	txtEndDate.text = calEndDate.SelectedDate.ToShortDateString

end Sub

Sub btnSaveData_Click(sender As Object, e As ImageClickEventArgs) 

	dim projectData as new structProject
	dim myProject as new projectpal.bo.boProject

	'setup structProject with data for update
	projectData.id = ctype(session("projectID"), integer)
	projectData.enddate = ctype(txtEndDate.text, datetime)
	projectData.description = ctype(txtdescription.text, string)
	projectData.status = ctype(ddlStatus.SelectedItem.value, integer)

	'update data
	myProject.Update(projectData)

end sub


Sub dgStage_Edit(sender As Object, e As DataGridCommandEventArgs)
        dgStage.EditItemIndex = e.Item.ItemIndex
        BindGrid()
End Sub 

Sub dgStage_Update(sender As Object, e As DataGridCommandEventArgs)

	dim stageData as new structStage
	dim myStage as new projectpal.bo.boStage
	dim mycontrol as control

	stageData.id = ctype(ctype(e.item.cells(0).controls(0), textbox).text, integer)
	stageData.name = ctype(e.item.cells(1).controls(0), textbox).text

	'update data
	myStage.Update(stageData)

	dgStage.EditItemIndex = - 1
    BindGrid()

end sub

Sub dgStage_Cancel(sender As Object, e As DataGridCommandEventArgs)
	dgStage.EditItemIndex = - 1
    BindGrid()
End Sub 



</script>



<table width="100%" border="0" cellspacing="3" cellpadding="3">

	<tr>
		<td align="right"><B>Project Name:</B></td>
		<td><asp:textbox id="txtProjectName" readonly="true" runat="server"/></td>
		<td align="right"><B>Status:</B></td>
		<td>
			<asp:dropdownlist 	id="ddlStatus" 
								runat="server" 
								AutoPostBack="false"
								readonly="true"
								width="150"	/>
			<asp:textbox id="txtStatus" readonly="true" runat="server"/>
		</td>
	</tr>
	<tr>
		<td colspan="4">
			<hr>
		</td>
	</tr>

	<tr>
		<td align="right"><B>Start Date:</B></td>
		<td><asp:textbox id="txtStartDate" readonly="true" runat="server"/></td>
		<td align="right"><B>End Date:</B></td>
		<td><asp:textbox id="txtEndDate" readonly="true" runat="server"/>
			<asp:ImageButton 	id="btnEndDate" 
					imageurl="../images/calendar.gif"
					OnClick="btnCalEndDate_Click" 
					causesValidation="false"
					visible="false"
					runat="server" />
		</td>

	</tr>
		<tr>
		<td colspan="4" align="right">
			<asp:calendar 	id="calEndDate" 
					visible="false" 
					OnSelectionChanged="calEndDate_Changed"
					runat="server" />
		</td>
	</tr>

	<tr>
		<td align="right" valign="top"><B>Description:</B></td>
		<td colspan="4"><asp:textbox id="txtDescription" textmode="multiline" columns="50" rows="3" readonly="true" runat="server"/></td>
	</tr>

	<tr>
		<td colspan="4" align="center" valign="bottom">
				<asp:ImageButton 	id="btnSaveData" 
					imageurl="../images/save.gif"
					OnClick="btnSaveData_Click" 
					causesValidation="false"
					visible="false"
					runat="server" />
		</td>
	</tr>
	<tr>
		<td colspan="4">
			<hr>
		</td>
	</tr>

	<tr>
		<td align="right" valign="top"><b>Project Stages</b></td>
		<td colspan="4">
			<asp:DataGrid id="dgStage" runat="server"
				           BorderColor="black"
				           BorderWidth="1"
				           CellPadding="3"
				           HeaderStyle-BackColor="#00aaaa"
				           AutoGenerateColumns="false"
						   OnEditCommand="dgStage_Edit"
				           OnCancelCommand="dgStage_Cancel"
				           OnUpdateCommand="dgStage_Update"	
			>
	
   				<Columns>
					<asp:BoundColumn	
							HeaderText="Stage Id" 
				            DataField="stageid"
							visible="false">
        	    	</asp:BoundColumn>


					<asp:BoundColumn	
							HeaderText="Stage Name" 
				            DataField="name">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="Not Started" 
				            DataField="Tasks Not Started"
							ReadOnly="true">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="In-Progress" 
				            DataField="Tasks In-Progress"
							ReadOnly="true">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="Completed" 
				            DataField="Tasks Completed"
							ReadOnly="true">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="Total" 
				            DataField="Total Tasks"
							ReadOnly="true">
        	    	</asp:BoundColumn>
				
					<asp:EditCommandColumn
                 		 EditText="<img src='../images/edit.gif' alt='Edit' border='0'>"
                 		 CancelText="<img src='../images/remove.gif' alt='Cancel' border='0'>"
                		 UpdateText="<img src='../images/add.gif' alt='Update' border='0'>"
               			 ItemStyle-Wrap="false"
						 ItemStyle-BackColor="#d3d3d3"
		                 HeaderText=""
    		             HeaderStyle-Wrap="false"
						 Visible="false" />



  	         </Columns>
				
		</asp:datagrid>


		</td>
	</tr>



</TABLE>

