<%@ Control debug="true" %>

<%@ import namespace="projectpal.bo" %>

<script runat="server">


private Sub Page_Load(Sender As Object, E As EventArgs)

	SetupFormData()
	
end sub



sub SetupFormData ()
	
	'setup screen for PM edit mode
	if session("ISPM") = 1 then
		
		'setup Staff grid Edit
		dgStaff.Columns(6).visible="true"

		'setup Staff Creation Button
		btnCreate.visible="true"

	end if

	BindFilters()
	BindGrid()
	
end Sub


sub BindFilters ()

	dim myStage as new projectpal.bo.boStage

	ddlStage.datasource = myStage.GetStagesByProject(Session("projectID"))
	ddlStage.DataTextField="name"
	ddlStage.DataValueField="stageid"
	ddlStage.DataBind()		
	ddlStage.selectedIndex = 0

end sub


sub BindGrid()

	dim myStaff as new projectpal.bo.boStaff

	if cbStageTasks.Checked then
        ddlStage.visible=true
		dgStaff.datasource = myStaff.GetStaffbyStage(ddlStage.selectedItem.value)
	else
        ddlStage.visible=false
		dgStaff.datasource = myStaff.GetStaff()
	end if

	dgStaff.databind()

end sub




Sub dgStaff_Edit(sender As Object, e As DataGridCommandEventArgs)
        dgStaff.EditItemIndex = e.Item.ItemIndex
        BindGrid()
End Sub 


Sub dgStaff_Update(sender As Object, e As DataGridCommandEventArgs)

	dim staffData as new structStaff
	dim myStaff as new projectpal.bo.boStaff

	staffData.id = ctype(ctype(e.item.cells(0).controls(0), textbox).text, integer)
	staffData.firstname = ctype(e.item.cells(1).controls(0), textbox).text
	staffData.lastname = ctype(e.item.cells(2).controls(0), textbox).text
	staffData.email = ctype(e.item.cells(3).controls(0), textbox).text

	'update data
	myStaff.Update(staffData)

	dgStaff.EditItemIndex = - 1
    BindGrid()

end sub


Sub dgStaff_Cancel(sender As Object, e As DataGridCommandEventArgs)
	dgStaff.EditItemIndex = - 1
    BindGrid()
End Sub 

sub ddlStageIndexChanged(sender As Object, e As EventArgs)
	bindGrid()
end sub


 Sub cbStageTasks_Changed(sender As Object, e As EventArgs)

	bindFilters() 
	bindgrid()

 End Sub 


Sub btnCreate_Click(sender As Object, e As ImageClickEventArgs) 

	panelView.Visible = false
	panelAdd.Visible = true	

end sub

Sub btnCreateStaff_Click(sender As Object, e As ImageClickEventArgs) 

	dim myStaff as new projectpal.bo.bostaff	
	dim staffData as new structStaff	

	'Load dataStaff  with staff information
	staffData.id = 0
	staffData.firstname = ctype(txtFirstname.text, string)
	staffData.lastname = ctype(txtlastname.text, string)
	staffData.email = ctype(txtemail.text, string)
	staffData.password = ctype(txtpassword1.text, string)
	staffData.isPM = 0

	myStaff.Create(staffData)

	panelView.Visible = true
	panelAdd.Visible = false

	bindGrid()

end sub

</script>


<asp:Panel id="panelView" runat="Server">

<table width="100%" border="0" cellspacing="3" cellpadding="3">

	<tr>
		<td>
				<asp:dropdownlist 	id="ddlStage" 
								runat="server" 
								AutoPostBack="true"
								OnSelectedIndexChanged="ddlStageIndexChanged"
								width="150"	visibile="false"/>
				&nbsp;&nbsp;&nbsp;&nbsp;
			<asp:CheckBox	id="cbStageTasks"
				runat="server"
			    Text="Show Staff assigned to tasks in this project:"
				OnCheckedChanged="cbStageTasks_Changed"
     			AutoPostBack="True"/>

		</td>
		<td align="right" valign="top">
				<asp:ImageButton 	id="btnCreate" 
					imageurl="../images/savebig.gif"
					OnClick="btnCreate_Click" 
					causesValidation="false"
					visible="false"
					runat="server" />

	</td>
	</tr>


	<tr>
		<td colspan="4">
			<hr>
		</td>
	</tr>

	<tr>
		<td>
				<asp:DataGrid id="dgStaff" runat="server"
				           BorderColor="black"
				           BorderWidth="1"
				           CellPadding="3"
				           HeaderStyle-BackColor="#00aaaa"
				           AutoGenerateColumns="false"
						   OnEditCommand="dgStaff_Edit"
				           OnCancelCommand="dgStaff_Cancel"
				           OnUpdateCommand="dgStaff_Update"	>
	
   				<Columns>
					<asp:BoundColumn	
							HeaderText="Staff Id" 
				            DataField="staffid"
							visible="false">
        	    	</asp:BoundColumn>


					<asp:BoundColumn	
							HeaderText="First Name" 
				            DataField="firstname"
							ItemSTyle-width="180">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="Last Name" 
				            DataField="lastname"
							ItemSTyle-width="180">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="email" 
				            DataField="email"
							ItemSTyle-width="180">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="Password" 
				            DataField="password"
							Visible="false">
        	    	</asp:BoundColumn>

					<asp:BoundColumn	
							HeaderText="isPM" 
				            DataField="ispm"
							Visible="false">
        	    	</asp:BoundColumn>
				
					<asp:EditCommandColumn
                 		 EditText="<img src='../images/edit.gif' alt='Edit' border='0'>"
                 		 CancelText="<img src='../images/remove.gif' alt='Cancel' border='0'>"
                		 UpdateText="<img src='../images/add.gif' alt='Update' border='0'>"
               			 ItemStyle-Wrap="false"
						 ItemStyle-BackColor="#d3d3d3"
		                 HeaderText=""
    		             HeaderStyle-Wrap="false"
						 Visible="false" />

  	         </Columns>
				
		</asp:datagrid>		


		</td>
	</tr>

</table>

</asp:Panel>



<asp:Panel id="panelAdd" visible="false" runat="Server">

<table width="100%" border="0" cellspacing="3" cellpadding="3">

<tr>
<td align="right">First Name: </td>
<td><asp:textbox id="txtFirstName" columns="20" runat="server" /></td>
<td align="right">Last Name</td>
<td><asp:textbox id="txtLastName" columns="20" runat="server" /></td>
</tr>

<tr>
<td align="right">Email: </td>
<td><asp:textbox id="txtEmail" columns="25" runat="server" /></td>
</tr>

<tr>
<td align="right">Password: </td>
<td><asp:textbox id="txtPassword1" textMode="password" columns="20" runat="server" /></td>
<td align="right">Re-Enter Password</td>
<td><asp:textbox id="txtPassword2" textMode="password" columns="20" runat="server" /></td>
</tr>

	<tr>
		<td colspan="4">
			<hr>
		</td>
	</tr>

	<tr>
		<td align="center" valign="bottom">
			<asp:ImageButton 	id="btnCreateStaff" 
				imageurl="../images/save.gif"
				OnClick="btnCreateStaff_Click" 
				causesValidation="true"
				runat="server" />
		</td>
	</tr>




</table>


</asp:Panel>

