Option Explicit
Option Strict

Imports System
Imports System.Data
Imports System.Data.SQLClient
Imports System.Configuration
Imports System.Collections

Imports projectpal.bo




namespace ProjectPal.bo


Public Class boProject

   public function Detail (projectid as integer) as structProject
  
  	dim myDSN as String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SQLConnection(myDSN)
	dim mySQLReader as SqlDataReader
	
	dim mySQLCommand as new SQLCommand("spGetProjectDetail", myConn)
	dim myStruct as new structProject()

	mySQLCommand.CommandType = CommandType.StoredProcedure
	mySQLCommand.Parameters.Add(New SqlParameter("@projectid", SqlDbType.int))
    mySQLCommand.Parameters("@projectid").Value = projectid

	myConn.Open()
	mySQLReader = mySQLCommand.ExecuteReader()

    while (mySQLReader.Read()) 
	  myStruct.id = mySQLReader.GetInt32(0)
      myStruct.name = mySQLReader.GetString(1)
      myStruct.startdate = mySQLReader.GetDateTime(2)
      myStruct.enddate = mySQLReader.GetDateTime(3)
      myStruct.description = mySQLReader.GetString(4)
      myStruct.pmid = mySQLReader.GetInt32(5)
      myStruct.status = mySQLReader.GetInt32(6)
      myStruct.statusname = mySQLReader.GetString(7)
    end while
	
	mySQLReader.Close
	myConn.Close

	Return ( myStruct )
  
  end function

 
  
  public function GetProjectsAsPM (email as string) as DataSet
  
 	dim myDataset as new Dataset
	dim myConn As new SQLConnection(ConfigurationSettings.AppSettings("ProjectPalDSN"))
	dim mySQLAdapter as new SQLDataAdapter("spGetProjectsAsPM", myConn)


	mySQLAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

	mySQLAdapter.SelectCommand.Parameters.Add(New SqlParameter("@email", SqlDbType.varchar))
    mySQLAdapter.SelectCommand.Parameters("@email").Value = email
  	
    mySQLAdapter.Fill(myDataSet, "Projects")
	
	Return myDataSet
  
  end function


  public function GetStatusCodes (curStatus as integer) as DataSet
  
 	dim myDataset as new Dataset
	dim myConn As new SQLConnection(ConfigurationSettings.AppSettings("ProjectPalDSN"))
	dim mySQLAdapter as new SQLDataAdapter("spGetStatusCodes", myConn)

	mySQLAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

	mySQLAdapter.SelectCommand.Parameters.Add(New SqlParameter("@curStatus", SqlDbType.int))
    mySQLAdapter.SelectCommand.Parameters("@curStatus").Value = curStatus
  	
    mySQLAdapter.Fill(myDataSet, "StatusCodes")
	
	Return myDataSet
  
  end function



public function GetProjectsAsStaff (email as string) as DataSet
  
 	dim myDataset as new Dataset
	dim myConn As new SQLConnection(ConfigurationSettings.AppSettings("ProjectPalDSN"))
	dim mySQLAdapter as new SQLDataAdapter("spGetProjectsAsStaff", myConn)

	mySQLAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

	mySQLAdapter.SelectCommand.Parameters.Add(New SqlParameter("@email", SqlDbType.varchar))
    mySQLAdapter.SelectCommand.Parameters("@email").Value = email
  	
    mySQLAdapter.Fill(myDataSet, "Projects")
	
	Return myDataSet
  
  end function


public function GetProjectStatistics (projectid as integer, email as string) as Hashtable
  
	dim myDSN as String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SqlConnection(myDSN)
	dim myCommand As SqlCommand 
	dim myParm As SqlParameter	
	dim myReader AS SQLDataReader
	dim myReturnCollection AS new Hashtable()
	
	myCommand = New SqlCommand("spGetProjectStatistics", myConn)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm = myCommand.Parameters.Add("@projectid", SqlDbType.int)
	myParm.Value = projectid

	myParm = myCommand.Parameters.Add("@email", SqlDbType.int)
	myParm.Value = email

	myConn.Open()

	myReader = myCommand.ExecuteReader()

 	myReader.Read()
	myReturnCollection("totalTasks") = myReader.GetInt32(0)
	myReturnCollection("totalMessages") = myReader.GetInt32(1)

	myReader.Close()

	Return myReturnCollection
  
  end function



function Create(staffData as structStaff, projectdata as structProject, stageData as ArrayList) as boolean

	dim myDSN As String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SqlConnection(myDSN)
	dim myCommand As SqlCommand
	dim myParm As SqlParameter
	dim myStaff AS new projectpal.bo.boStaff()

try	
	myConn.Open()

	'before we create a PM need to make sure PM does not already exist
	if myStaff.Authenticate (staffData.email, staffData.password) then
		'PM in Database, get his details
		staffData = myStaff.Detail(staffData.email)
		projectData.pmid = ctype(staffData.id, integer)
	else
		'PM not in database create him
		myCommand = New SqlCommand("spCreateStaff", myConn)
		myCommand.CommandType = CommandType.StoredProcedure
		myParm = myCommand.Parameters.Add("@staffdata", SqlDbType.varchar, 250)
		myParm.Value =  staffData.toinsertstring()

		myParm  = myCommand.Parameters.Add("@staffid", SqlDbType.int)
		myParm.Direction = ParameterDirection.Output

		myCommand.ExecuteNonQuery()
	
		projectData.pmid = ctype(myCommand.Parameters("@staffid").Value, integer)
	end if

	'Project Creation
	myCommand = New SqlCommand("spCreateProject", myConn)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm = myCommand.Parameters.Add("@projectdata", SqlDbType.varchar, 2048)
	myParm.Value =  projectData.toinsertstring()

	myParm  = myCommand.Parameters.Add("@projectid", SqlDbType.int)
	myParm.Direction = ParameterDirection.Output

	myCommand.ExecuteNonQuery()

	
	'Stage creation
	Dim myEnum As System.Collections.IEnumerator = stageData.GetEnumerator()
	Dim myProjectid as integer = ctype(myCommand.Parameters("@projectid").Value, integer)

	While myEnum.MoveNext()
		
		if ctype(myEnum.Current(), string).length > 0 then

			myCommand = New SqlCommand("spCreateStage", myConn)
			myCommand.CommandType = CommandType.StoredProcedure		
			myParm = myCommand.Parameters.Add("@projectid", SqlDbType.int)
			myParm.Value = myProjectid

			myParm = myCommand.Parameters.Add("@stageData", SqlDbType.varchar, 50)
			myParm.Value = ctype(myEnum.Current(), string)
			myCommand.ExecuteNonQuery()
		
		end if

	End While
		

catch e as SqlException
	throw e
	
finally
	myConn.Close

end try

return(true)

end function



function Update(projectdata as structProject) as boolean

	dim myDSN As String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SqlConnection(myDSN)
	dim myCommand As SqlCommand
	dim myParm As SqlParameter

try	
	myConn.Open()

	'Project Update
	myCommand = New SqlCommand("spUpdateProject", myConn)
	myParm = myCommand.Parameters.Add("@projectid", SqlDbType.int)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(projectData.id, integer)

	myParm = myCommand.Parameters.Add("@description", SqlDbType.varchar, 2048)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(projectData.description ,string)

	myParm = myCommand.Parameters.Add("@endDate", SqlDbType.datetime)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(projectData.enddate, datetime)

	myParm = myCommand.Parameters.Add("@status", SqlDbType.int)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(projectData.status, integer)

	myCommand.ExecuteNonQuery()

catch e as SqlException
	throw e
	
finally
	myConn.Close

end try

return(true)

end function


End Class

 public class structProject
	Public id As Integer			' companyid (internal use only)
    Public name As String   		' project name
    Public startDate As system.DateTime  	' starting date of project
	Public endDate As system.DateTime  	' ending date of project
	Public description AS String	' projects description
	Public pmid as integer			'PM ID of staff assigned to project
	Public status as integer		'Status code for the project
	Public statusname as string		'status string

	public function toInsertString () as string

		return(	"'" + ctype(name, string) +"', '" + _
					  ctype(description, string) +"', '" + _
					  ctype(startdate, string) +"', '" + _
					  ctype(enddate, string) +"', " + _
					  ctype(pmid, string)+", " + _
					  ctype(status, string) )

	end function

 End Class


end namespace



